#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>

#define BUFSIZE 1024
#define PORT 4610
#define SERVER_PORT 8080
double pl,pd,u;

main( int argc, char **argv )
{
	int new_sd,sd2,sd3;
	srand(time(NULL));

	char Rxbuf_from_Rx[BUFSIZE],Rxbuf_from_Tx[BUFSIZE];
	int parent,child,nbytes,n1bytes;
	int channel_delay=4000000;

	struct sockaddr_in server;
	struct hostent *server_host;

	/* Create socket */
	sd2=socket(AF_INET, SOCK_STREAM, 0);
	if ( sd2 == -1 ) {
		fprintf(stderr, "%s: cannot create socket: ", argv[0]);
		perror(0);
		exit(1);
	}else{
		printf("%s: created listening socket\n", argv[0]);
	}
    bzero(&server, sizeof(server)); 

	/* Set up struct sockaddr_in */
	server.sin_family = AF_INET;
	server.sin_addr.s_addr = inet_addr("127.0.0.1");
	server.sin_port   = htons(SERVER_PORT);

	connect(sd2,(struct sockaddr *)&server, sizeof(server));

	struct sockaddr_in in_sa;

	new_sd =socket(AF_INET,SOCK_STREAM,0);
	if (new_sd == -1){
		fprintf(stderr,"%s: cannot create listening socket: ",argv[0]);
		perror(0);
		exit(1);
	}else{
		printf("%s: created listening socket\n", argv[0]);
	}

    bzero(&in_sa, sizeof(in_sa));

	//assign IP, PORT
	in_sa.sin_family = AF_INET;
	in_sa.sin_addr.s_addr = htonl(INADDR_ANY);
	printf("%s\n", in_sa.sin_addr.s_addr);
	in_sa.sin_port = htons(PORT);
	printf("%d\n", in_sa.sin_port);

	if(bind (new_sd, &in_sa,sizeof(in_sa))<0){
		fprintf(stderr,"%s: cannot bind listening socket: ",argv[0]);
		perror(0);
		exit(1);
	}else{
		printf("%s: listening socket binded\n", argv[0]);
	}

	// Initialize a listen queque
	if(listen(new_sd,5)<0){
		fprintf(stderr, "%s: cannot listen on socket: ",argv[0]);
		perror(0);
		exit(1);
	}else{
		printf("%s: listening on socket\n", argv[0]);
	}

	socklen_t len = sizeof(in_sa);
	if((sd3=accept(new_sd,(struct sockaddr *)&in_sa,&len))<0)
		signal(SIGPIPE,SIG_IGN);

	printf("\nGive Channel Probability for Loss:");
	scanf("%lf",&pl);
	printf("\nGive Channel Probability for Delay:");
	scanf("%lf",&pd);

	if(fork()==0 ){
		child=getpid();
		while((n1bytes=read(sd2,Rxbuf_from_Rx,BUFSIZE))>0){
			Rxbuf_from_Rx[n1bytes] = '\0';
			printf("Channel Recieved Ack %c from Receiver \n\n", Rxbuf_from_Rx[0]);
			write(sd3,Rxbuf_from_Rx,n1bytes);
		}
	}else{
		parent=getppid();
		while((nbytes=read(sd3,Rxbuf_from_Tx,BUFSIZE))>0){
			Rxbuf_from_Tx[nbytes] = '\0';
			printf("Channel Recieved from Transmitter: %s\n", Rxbuf_from_Tx);
			u =1+rand()%100;
			u=u/100;
			if (pl>=u){
				printf("packet %c lost\n", Rxbuf_from_Tx[1]);
			}else if ((pl<u)&&(pd>=u)){
				printf("packet %c delay for %d microseconds\n", Rxbuf_from_Tx[1],channel_delay);
				usleep(channel_delay);
				write(sd2, Rxbuf_from_Tx,nbytes);
			}else if ((pl<u)&&(pd<u)){
				printf("packet %c send successfully\n", Rxbuf_from_Tx[1]);
				write(sd2, Rxbuf_from_Tx,nbytes);
			}else{
				printf("Unexpected error\n");
			}
		}
	}
}